- Main Page
- Related Pages
- Modules
- Classes
- Examples

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Friends

# MArrayDataHandle Class Reference

# OpenMaya - API module for common classes

Search for all occurrences

## Detailed Description

Data block handle for array data.

An MArrayDataHandle is a smart pointer into a data block (MDataBlock) that handles access to array data. MArrayDataHandle supports attributes that can have an array of data.

The array indices do not have to be continuous. The array can be sparse. Thus, an array could have four elements with the indicies 1, 6, 8, and 10.

MArrayDataHandle methods cannot be assumed to be threadsafe. The jumpToElement() method sets an internal pointer so definitely cannot be called by multiple threads simultaneously.

Examples:

  anisotropicShader.cpp, apiMeshShape.cpp, apiMeshShape.h, backfillShader.cpp, dynExprField.cpp, fullLoftNode.cpp, geometrySurfaceConstraint.cpp, lambertShader.cpp, multiCurveNode.cpp, ownerEmitter.cpp, ownerEmitter.h, phongShader.cpp, shadowMatteShader.cpp, simpleEmitter.cpp, simpleEmitter.h, stringFormatNode.cpp, sweptEmitter.cpp, sweptEmitter.h, testNucleusNode.cpp, torusField.cpp, and weightListNode.cpp.

`#include <MArrayDataHandle.h>`

List of all members.

## Public Member Functions
| MArrayDataHandle (const MDataHandle &in, MStatus *ReturnStatus=NULL)
| Copy constructor.
MDataHandle | inputValue (MStatus *ReturnStatus=NULL)
| Gets a handle into this data block for the current array element.
MDataHandle | outputValue (MStatus *ReturnStatus=NULL)
| Gets a handle into this data block for the current array element.
MArrayDataHandle | inputArrayValue (MStatus *ReturnStatus=NULL)
| Gets a handle into this data block for the current array element.
MArrayDataHandle | outputArrayValue (MStatus *ReturnStatus=NULL)
| Gets a handle into this data block for the current array element.
MStatus | next ()
| Advance to the next element in the array.
unsigned int | elementCount (MStatus *ReturnStatus=NULL)
| Returns the number of elements in the array.
unsigned int | elementIndex (MStatus *ReturnStatus=NULL)
| Returns the index that we are currently at in the array.
MStatus | jumpToElement (unsigned int index)
| Jump to a specific element in the array.
MStatus | jumpToArrayElement (unsigned int position)
| Jump to a specific array element in the array.
MStatus | setClean ()
| Marks the data that is represented by this handle as being clean.
MStatus | setAllClean ()
| Marks every element of the array attribute represented by the handle as clean.
MArrayDataBuilder | builder (MStatus *ReturnStatus=NULL)
| Returns a builder for this handle's array so that it can be expanded.
MStatus | set (MArrayDataBuilder &builder)
| Sets the data for this array from the data in the builder object.
| MArrayDataHandle (const MArrayDataHandle &other)
| Copy constructor.
MArrayDataHandle & | operator= (const MArrayDataHandle &other)
| Assignment operator.
## Static Public Member Functions
static const char * | className ()
| Returns the name of this class.
## Friends
class | MDataBlock Search for all occurrences
class | MArrayDataBuilder Search for all occurrences

## Constructor & Destructor Documentation

MArrayDataHandle | ( | const MDataHandle & | in,
|  | MStatus * | ReturnStatus = `NULL`
| ) |  |

Copy constructor.

Creates an new array data handle from the specified data handle.

This method can be used to access an array attribute that is a child of a compound array. Example: weightList[].weights[]

This method will only work for data handles to attributes that are arrays.

Parameters:

  [in] | in | Handle to the child array attribute.
  [out] | ReturnStatus | return status

Status Codes:
  - kSuccess operation successful
  - kInvalidParameter source handle is null or is not an array

MArrayDataHandle | ( | const MArrayDataHandle & | other | ) | `[inline]`

Copy constructor.

Parameters:

  [in] | other | the source object to copy from.

## Member Function Documentation

MDataHandle inputValue | ( | MStatus * | ReturnStatus = `NULL` | ) |

Search for all occurrences

Gets a handle into this data block for the current array element.

The data represented by the handle will be valid. If the data is from an dirty connection, then the connection will be evaluated.

It is important to note that you can not call inputValue on an element that is greater than the elementCount in this arrayDataHandle. That is, calls to inputValue must be protected by a call to elementCount to ensure the element exists. If this is not done, the call to inputValue will fail with an invalidParameter error.

The data handle that this arrayDataHandle represents must come from a valid data block, such as one returned from one of the MDataBlock methods like MDataBlock::inputValue(). If a data handle created and returned from MPlug::getValue() or MPlug::asMDataHandle() is passed to this arrayDataHandle, then the use of this method will be invalid.

Parameters:

  [out] | ReturnStatus | return status

Returns:
  Data handle for the current element's data

Status Codes:
  - kSuccess operation successful
  - kInvalidParameter the requested element is out of range
  - kFailure an object error has occurred

Examples:
  anisotropicShader.cpp, backfillShader.cpp, dynExprField.cpp, fullLoftNode.cpp, geometrySurfaceConstraint.cpp, lambertShader.cpp, ownerEmitter.h, phongShader.cpp, shadowMatteShader.cpp, simpleEmitter.h, stringFormatNode.cpp, sweptEmitter.h, testNucleusNode.cpp, torusField.cpp, and weightListNode.cpp.

MDataHandle outputValue | ( | MStatus * | ReturnStatus = `NULL` | ) |

Search for all occurrences

Gets a handle into this data block for the current array element.

The data is not guaranteed to be valid. Therefore, this handle should only be used for writing over the data.

This method can also be used to retrieve handles to individual elements of non-datablock array handles, such as those returned by MPlug::getValue() and MPlug::asMDataHandle().

Parameters:

  [out] | ReturnStatus | return status

Returns:
  Data handle for the current element's data

Status Codes:
  - kSuccess operation successful
  - kFailure an object error has occurred

Examples:
  apiMeshShape.cpp.

MArrayDataHandle inputArrayValue | ( | MStatus * | ReturnStatus = `NULL` | ) |

Search for all occurrences

Gets a handle into this data block for the current array element.

This method should be used when the array elements are also arrays. The data represented by the handle will be valid. If the data is from an dirty connection, then the connection will be evailuated.

It is important to note that you can not call inputArrayValue on an element that is greater than the elementCount in this arrayDataHandle. That is, calls to inputValue must be protected by a call to elementCount to ensure the element exists. If this is not done, the the call to inputArrayValue will fail with an invalidParameter error.

The data handle that this arrayDataHandle represents must come from a valid data block, such as one returned from one of the MDataBlock methods like MDataBlock::inputValue(). If a data handle created and returned from MPlug::getValue() or MPlug::asMDataHandle() is passed to this arrayDataHandle, then the use of this method will be invalid.

Parameters:

  [out] | ReturnStatus | return status

Returns:
  Data handle for the current element's data

Status Codes:
  - kSuccess operation successful
  - kInvalidParameter the current item is not an array or the requested element is out of range.
  - kFailure an object error has occurred

Examples:
  apiMeshShape.cpp.

MArrayDataHandle outputArrayValue | ( | MStatus * | ReturnStatus = `NULL` | ) |

Search for all occurrences

Gets a handle into this data block for the current array element.

This method should be used when the array elements are also arrays. The data is not guaranteed to be valid. Therefore, this handle should only be used for writing over the data.

The data handle that this arrayDataHandle represents must come from a valid data block, such as one returned from one of the MDataBlock methods like MDataBlock::inputValue(). If a data handle created and returned from MPlug::getValue() or MPlug::asMDataHandle() is passed to this arrayDataHandle, then the use of this method will be invalid.

Parameters:

  [out] | ReturnStatus | return status

Returns:
  Data handle for the current element's data

Status Codes:
  - kSuccess operation successful
  - kInvalidParameter the current item is not an array
  - kFailure an object error has occurred

MStatus next | ( |  | ) |

Search for all occurrences

Advance to the next element in the array.

These may be sparse arrays so the next consecutive element may not necessarily have a consecutive index.

Returns:
  - MS::kSuccess if there was a next element
  - MS::kFailure if the object is invalid or there is no next element

Examples:
  anisotropicShader.cpp, apiMeshShape.cpp, backfillShader.cpp, fullLoftNode.cpp, geometrySurfaceConstraint.cpp, lambertShader.cpp, phongShader.cpp, and shadowMatteShader.cpp.

unsigned int elementCount | ( | MStatus * | ReturnStatus = `NULL` | ) |

Search for all occurrences

Returns the number of elements in the array.

Parameters:

  [out] | ReturnStatus | return status

Returns:
  The number of elements

Status Codes:
  - kSuccess operation successful
  - kFailure an object error has occurred

Examples:
  anisotropicShader.cpp, backfillShader.cpp, fullLoftNode.cpp, geometrySurfaceConstraint.cpp, lambertShader.cpp, phongShader.cpp, shadowMatteShader.cpp, and weightListNode.cpp.

unsigned int elementIndex | ( | MStatus * | ReturnStatus = `NULL` | ) |

Search for all occurrences

Returns the index that we are currently at in the array.

It is possible for the index to be invalid, in which case the return status will report an error. These may be sparse arrays so the element index returned will be a logical index.

Parameters:

  [out] | ReturnStatus | return status

Returns:
  The current element's logical index

Status Codes:
  - kSuccess operation successful
  - kFailure current element has an invalid index, or this function set has an invalid object

Examples:
  apiMeshShape.cpp.

MStatus jumpToElement | ( | unsigned int | index | ) |

Search for all occurrences

Jump to a specific element in the array.

The array is sparse, so the indices may not be consecutive.

NOTE: The index is the logical element index, which may be sparse. Jumping to an element is done through a binary search.

Parameters:

  [in] | index | the logical index to jump to

Returns:
  Status code

Status Codes:
  - MS::kSuccess the operation was successful
  - MS::kInvalidParameter the given index does not exist
  - kFailure an object error has occurred

Examples:
  dynExprField.cpp, fullLoftNode.cpp, ownerEmitter.h, simpleEmitter.h, stringFormatNode.cpp, sweptEmitter.h, testNucleusNode.cpp, torusField.cpp, and weightListNode.cpp.

MStatus jumpToArrayElement | ( | unsigned int | position | ) |

Search for all occurrences

Jump to a specific array element in the array.

This method can be used to iterate over the entire array.

NOTE: Jumping to an array element does not require a search, since the array indices are non-sparse. The MArrayDataHandle::elementIndex() method can be used to determine the logical index related to the current array index.

Parameters:

  [in] | position | the array position to jump to

Returns:
  Status code

Status Codes:
  - MS::kSuccess the operation was successful
  - MS::kInvalidParameter the given array element does not exist
  - kFailure an object error has occurred

Examples:
  weightListNode.cpp.

MStatus setClean | ( |  | ) |

Search for all occurrences

Marks the data that is represented by this handle as being clean.

This should be done after recalculating the data from the inputs.

The data handle that this arrayDataHandle represents must come from a valid data block, such as one returned from one of the MDataBlock methods like MDataBlock::inputValue(). If a data handle created and returned from MPlug::getValue() or MPlug::asMDataHandle() is passed to this arrayDataHandle, then the use of this method will be invalid.

Returns:
  Return status

Status Codes:
  - kSuccess operation successful
  - kFailure an object error has occurred

MStatus setAllClean | ( |  | ) |

Search for all occurrences

Marks every element of the array attribute represented by the handle as clean.

This method should be used if a compute function is asked to compute a single element of a multi, but instead calculates all the elements. Calling setAllClean in this situation will prevent further calls to the node's compute method for the other elements of the multi.

The data handle that this arrayDataHandle represents must come from a valid data block, such as one returned from one of the MDataBlock methods like MDataBlock::inputValue(). If a data handle created and returned from MPlug::getValue() or MPlug::asMDataHandle() is passed to this arrayDataHandle, then the use of this method will be invalid.

Returns:
  Return status

Status Codes:
  - kSuccess operation successful
  - kFailure an object error has occurred

Examples:
  apiMeshShape.cpp, and multiCurveNode.cpp.

MArrayDataBuilder builder | ( | MStatus * | ReturnStatus = `NULL` | ) |

Search for all occurrences

Returns a builder for this handle's array so that it can be expanded.

This method will fail if the current array does not support array data builders. This can be changed in a node's initialize routine using the setUsesArrayDataBuilder method in MFnAttribute.

The data handle that this arrayDataHandle represents must come from a valid data block, such as one returned from one of the MDataBlock methods like MDataBlock::inputValue(). If a data handle created and returned from MPlug::getValue() or MPlug::asMDataHandle() is passed to this arrayDataHandle, then the use of this method will be invalid.

Parameters:

  [out] | ReturnStatus | return status

Returns:
  The builder object

Status Codes:
  - kSuccess operation successful
  - kInvalidParameter This item does not support array data builders
  - kFailure an object error has occurred

Examples:
  apiMeshShape.cpp, ownerEmitter.cpp, simpleEmitter.cpp, sweptEmitter.cpp, and torusField.cpp.

MStatus set | ( | MArrayDataBuilder & | builder | ) |

Search for all occurrences

Sets the data for this array from the data in the builder object.

The data handle that this arrayDataHandle represents must come from a valid data block, such as one returned from one of the MDataBlock methods like MDataBlock::inputValue(). If a data handle created and returned from MPlug::getValue() or MPlug::asMDataHandle() is passed to this arrayDataHandle, then the use of this method will be invalid.

Parameters:

  [in] | builder | the builder object

Returns:
  Return status

Status Codes:
  - kSuccess operation successful
  - kInvalidParameter the builder passed is invalid
  - kFailure an object error has occurred

Examples:
  apiMeshShape.cpp, and multiCurveNode.cpp.

MArrayDataHandle & operator= | ( | const MArrayDataHandle & | other | ) | `[inline]`

Assignment operator.

Parameters:

  [in] | other | the source object to copy from.

const char * className | ( |  | ) | `[static]`

Search for all occurrences

Returns the name of this class.

Returns:
  Name of this class.

MArrayDataHandle MArrayDataHandle MArrayDataHandle MArrayDataHandle MArrayDataHandle MArrayDataHandle MArrayDataHandle MArrayDataHandle MArrayDataHandle MArrayDataHandle
MArrayDataHandle MArrayDataHandle MArrayDataHandle MArrayDataHandle MArrayDataHandle MArrayDataHandle MArrayDataHandle MArrayDataHandle MArrayDataHandle MArrayDataHandle